#!/usr/bin/env python

# mikrologg
# 190117 fixat bugg som tog bort temp.korrigering for lager 2
# 190117 argv[2] = utfil
# 190118 temperatur sanks nu temporart vid sjalva filamentbytet. Anvand alltsa ORIGINAL-MK3-filament-temperaturer INTE MMU-temperaturer
# 190131 buggfix: bortglomd else-gren for initialtemperatur
# 190131 temp.hojningar flyttas ocksa - till direkt efter tool change (T0...T4)
# 190131 buggfix: forsta set extruder temp & set temp lamnas ororda
# 190131 tydligare utskrifter
# 190201 korrigerar for att slic3r ibland glommer satta korrekt temp vid forsta filamentbytet
# 190201 battre flakthantering for snabbare byten
# 190201 vantar tempdiff. sekunder istf M109 for att spara tid, sa inte filamentet mjuknar
# 190207 sankning nu ca 16 rader INNAN man nar UNLOAD ty initialt lyft kommer dessforinnan
# 190211 temperatursankning nu olika beroende av initialtemperatur (BVOH/PLA/PETG...) Borde kolla i filen efter material, ej bara temp.
# 190211 temperatursankning baserat pa temperatur alt. BVOH (lases ur filen)
# 190212 temperatur skalas nu upp/ner UNDER wipe-fasen efter filamentbytet
# 190214 tagit bort initialtemperatur - behovs nu inte och bara orsakade problem vid forsta skiftet
# 190215 temp.aterstallning vid WIPE start (inte LOAD, det var fel)
# 190215 final temp always at toolchange END
# 190227 nu en liten temp.HOJNING innan wipe borjar -> battre wipe
# 190227 ingen paus (G4 S) i slutet a wipe (gradient fixar det) eller innan wipe (processen tar tillrackligt med tid)
# 190227 temperatur + flakt satts alltid vid wipe END
# 190227 detaljerad temperaturgenomgang av materialen (laser forst material- och temperatur-definitioner)
# 190303 detaljerad gradient i wipe tower
# 190303 korrekta temperaturer aven forsta lagret / varvet
# 190303 separat bugg-kod borttagen, koden upprensad
# 190306 langsam rorelse istallet for pause vid temp.andring
# 190413 vissa temperaturer anpassade. Anvand coolingmoves=1 for PLA, coollingmoves=1 for BVOH 
# 190416 anpassade gcoder (till slic3r) skrivs ut
# 190706 MoldLAY added
# 190720 SKULPT added
# 190802 Material definitions now stored in array
# 191101 brassfil temperature bug fixed
# 191101 ASA,T-GLASE added
# 20.0207 new filament types added
# 20.0207 new interface (outfilename is computed from infile)
# 20.0208 BHOV renamed to PVA for slic3r internal junk
# ; wiping_volumes_extruders = 0,100,0,100,0,100,0,100,0,100
# ; wiping_volumes_matrix = 0,100,100,100,100,100,0,100,100,100,100,100,0,100,100,100,100,100,0,100,100,100,100,100,0
# ; temperature = 215,215,215,240,215
# 20.0318 ELIXIR wipe temp changed to 210 degrees. Use VERY TIGHT idler screw setting
# 20.0329 changed min.temp as 175 is too low for extruder motor to move
# 20.0417 ELIXIR wipe temp changed to 220 degrees. Use VERY TIGHT idler screw setting
# 20.0417 ELIXIR wipe temp changed to 190 degrees. Use QUITE FAST remove VERY TIGHT idler screw setting
# 20.0426 removed hard temperature limit 250 degree
# 20.0426 now wipe temperature will only be boosted if going from higher to lower filament temperature
# 20.0427 stangt av wipetemperaturokning helt (WIPETEMPERATUROKNING = 0)
# 20.0531 FLEX-slow (maste kontrolleras)
# 20.0602 Aterstallningstemp satts redan INNAN Tn
# 20.0618 paustiden korrigerad (tiden forutom FILAMENTURLADDTID ) for att temp sanks innan Tn
# 20.0618 ATER-stallningspausen korrigerad med FILAMENTBYTESTID

# test: 
# rod->vit: 140
# vit->rod: 100
# PLA<->PETG: 100 (enligt mmutest_purge=100__1=FrimmelPLA_4=FrimmelPET.gcode)
# PLA->BVOH: 100
# PETG->BVOH: 200
# BVOH->allt annat: 200

# temperaturer:
# PETG=140, PLA=115 fungerar bra tillsammans

# PETG=130-140,  BVOH=115 fungerar uselt (efter korr) eftersom wipe tower splittras sonder
# PETG130-140 fungerar INTE med PLA nar wipe tower "tunt"

# 190227: raket, 3xcoolingmove, ner till 200grader, deltatemp=1, purge60rod+120vit riktigt bra, purg40rod+70vit,deltatemp=2=xxx

## slicer: * 1mm supportavstand, 15% fill, filament 210grader-other, "with sheath around support" ##  Denna kod: korr=-5grader


# ["Slic3r name"],	["Filament brand and type"],	[Filament unload temp],	[Max wipe temp]
# WARNING! DO NOT SET 175 degrees or lower - SWAP WILL FAIL (HARDWARE SECURITY RESTRICTION)
filamentsorter=[
[["XT"],        ["ColorFABB XT"],                    [210],	[280]],
[["WoodFILL"],  ["ColorFABB Woodfill"],   [195],	[250]],
[["EasyWoodFILL"],  ["FormFutura EasyWoodfill"],   [195],	[250]],
[["TimberFILL"],["Fillamentum Timberfill"],   [180],	[220]],
[["StoneFILL"],	["FormFutura Stonefill"],     [200],	[250]],
[["SteelFILL"],	["ColorFABB/xxx Steelfill"],  [195],	[250]],
[["BrassFILL"],	["ColorFABB Brassfill"],      [195],	[250]],
[["CPE-HG100"],	["Fillamentum CPE-HG100"],    [195],	[280]],
[["PET"],	["PETG"],	        [195],	[260]],
[["T-GLASE"],	["T-GLASE"],	        [205],	[280]],
[["ASA"],	["ASA"],	        [220],	[290]],
[["NinjaFLEX"],	["NinjaFLEX 85A"],	[195],	[260]],
[["FilaFLEX"],	["FilaFLEX 82A"],	[195],	[260]],
[["SemiFLEX"],	["SemiFLEX 98A"],	[195],	[260]],
[["PLA"],	["PLA"],	        [205],	[250]],
[["PLA-PHA"],	["PLA-PHA"],	        [195],	[250]],
[["PLAmmu190"],	["PLA mmu190"],	        [190],	[250]],
[["SKULPT"],	["SKULPT"],	        [180],	[230]],
[["MoldLAY"],	["MoldLAY"],	        [205],	[200]],
[["PP"],	["Polypropylen (PP)"],	[200],	[250]],
[["GF30PP"],	["XStrand GF30-PP"],	[200],	[270]],
[["ELIXIR"],	["PolyAlchemy ELIXIR"],	[190],	[250]],
[["NYLON"],	["Taulman Nylon 345"],	[195],	[260]],
[["3dkTOP"],	["3dkTOP"],	        [240],	[290]],
[["PVA"],	["BVOH / PVA - must be named PVA for slic3r internal"],	[200],	[250]]]

# filamentsort = filter(lambda element: 'XT' in element[0], filamentsorter)
# slicername=filamentsort[0][0][0]
# brandandtype=filamentsort[0][1][0]
# unloadtemp= filamentsort[0][2][0]
# maxwipetemp= filamentsort[0][3][0]

import re
import sys

if len(sys.argv) != 2:
    print "Avbryter ty antal argument="+str(len(sys.argv)-1)+". Anropa med: korrigera_gcode_temperaturer.py infil"
    exit()
print 'Konverterar fil: ', str(sys.argv[1])

# filnamn = "/home/frimmel/projekt3D/treefrog_0.15mm_2=Stone_3=Stone_4=Brass.gcode"
filnamn = str(sys.argv[1])

f = open(filnamn, "r")
lines = f.readlines()

# SANKNING = 5 # temp reduction during the actual filament change
DELTATEMPFAKTOR = 1.5 # 1.0 = 1s/grad   100=ca ingen paus  # 0.66 # skalar tidsskillnaden for att fa paus i sekunder
DELTATEMPNEDFAKTOR = 2.0 # 1.0 = 1s/grad   100=ca ingen paus  # 0.66 # skalar tidsskillnaden for att fa paus i sekunder
ANTALRADERINNANUNLOAD = 12 # 8=teoretiskt korrekt position, 32 = en bit innan i tid  # temp.sankning INNAN uppdragning vilket sker nagra rader INNAN UNLOAD
WIPETEMPERATUROKNING = 0 # 20=hojning fran normaltemperatur for battre wipe
FILAMENTBYTESTID = 40 # med temp.byte INNAN Tx sa hinner den storsta biten redan korrigeras
FILAMENTURLADDTID = 20 # tiden som redan finns for att sanka temperaturen

senarelagg = [];
senarelaggtyp = 0; # 0=ingen, 1=nerat (forst efter wipe), 2=uppat (direkt efter T1)
senarelaggflakt = [];
senastetemp=0;
temperatur = []
utlines=[]
flakt=[]
materialtyp = []
kommandematerialtyp = []

aterstallningstemperatur = [];
aterstallningstid = [] ;
nyttmaterial= []

wipestartlineindex = []
wipeendlineindex = []

aktivfas = [] # TOOLCHANGE START -> TOOLCHANGE UNLOAD -> (Tn) -> TOOLCHANGE LOAD  -> TOOLCHANGE WIPE ->  TOOLCHANGE END 

# ;--------------------
#; CP TOOLCHANGE START
#; toolchange #1
#; material : DEFAULT (PLA)
#;--------------------

# first, locate relevant knowledge from gcode file


# MATERIAL
#  "; filament_type = PET;PLA;PLA;PLA;PVA"
materialtyper = filter(lambda element: '; filament_type = ' in element, lines)[0].split()[3].split(";")
# -> materialtyper[0]..[4]

# FLAKT
flaktmax = filter(lambda element: '; max_fan_speed = ' in element, lines)[0].split()[3].split(",")

# MATERIALTEMPERATURER
materialtemperaturer = filter(lambda element: '; temperature = ' in element, lines)[0].split()[3].split(",")
print materialtemperaturer

# WIPE TOWER WIDTH
wipetowerbredd = filter(lambda element: '; wipe_tower_width = ' in element, lines)[0].split()[3]

paustid = 0

for line in lines:
    ord = line.split()
    utline = line
    if 'T' in line and ord[0][0] == "T":
        pm = re.compile("T\d+")
        svar = pm.match(ord[0])
        if temperatur == []: # slic3r bug: no new temp set first time - read it from table
            temperatur = materialtemperaturer[int( ord[0][1] )]
            materialtyp = materialtyper[int( ord[0][1] )]
            flakt = flaktmax[int( ord[0][1] )]
            print "Temperature was MISSING so setting according to temperature comment for T"+ord[0][1]+" (type="+materialtyp+", temp="+temperatur+", fan="+flakt+" )"
        if svar:
            print  "T"+ord[0][1]
            extrudernummer = ord[0][1]
            kommandematerialtyp=materialtyper[int(extrudernummer)]
        if extrudernummer != [] and "FLEX" in kommandematerialtyp:  # Obs! KOMMANDE (inte nuvarande) materialtyp
            utlines.append("; FRIMMEL Tn SLOW for FLEX (reset by slic3r at Tn)\n")
            utlines.append("M220 S30\n")
            print  "; FRIMMEL Load SLOW for FLEX"
        if aterstallningstemperatur != []:
            utlines.append( "; FRIMMEL temp.aterstallning redan innan filamenturdrag\n")
            utlines.append("M104 S"+str(aterstallningstemperatur)+" ; "+materialtyp+"\n")
            utlines.append("M106 S0\n") 

#
# nice printouts
#
    if '; CP TOOLCHANGE START' in line:
        print  line[:-1]
        aktivfas = "TOOLCHANGE START"
    if '; CP TOOLCHANGE UNLOAD' in line:
        print  line[:-1]
        aktivfas = "TOOLCHANGE UNLOAD"
    if '; CP TOOLCHANGE LOAD' in line:
        print  line[:-1]
        aktivfas = "TOOLCHANGE LOAD"
    if '; CP TOOLCHANGE WIPE' in line:
        print  line[:-1]
        aktivfas = "TOOLCHANGE WIPE"
    if '; CP TOOLCHANGE END' in line:
        print  line[:-1]
        aktivfas = "TOOLCHANGE END"
#
# move wipe tower temperature position
#
    if 'M104' in line and ord[0]=="M104": # for att inte jamfora tomma rader
        print line[:-1]
        temperatur=ord[1][1:]
    if 'M104' in line and ord[0]=="M104" and ord[1] != "S0": # for att inte ta bort nedstangning
        if not ("; set " in line) : # FORSTA sankningen (lager 1->2) har en temp.kommentar
            senarelagg = line; # aktivera ny M104
            if int(senastetemp) > int(temperatur):
                senarelaggtyp = 1; # sanker temp - sent i wipe tower
                senarelaggtid = (int(senastetemp) - int(temperatur)) / DELTATEMPFAKTOR # approximate delay when changing between the temperatures - NOT to use M109
            else:
                senarelaggtyp = 2; # hojer temp - direkt efter tool change
                senarelaggtid = (int(temperatur) - int(senastetemp)) / DELTATEMPFAKTOR # approximate delay when changing between the temperatures - NOT to use M109
            utline = []
            print "tar bort: "+senarelagg[:-1]
        senastetemp = temperatur;
    if 'M106' in line and ord[0]=="M106": # for att inte jamfora tomma rader
        print line[:-1]
        flakt=ord[1][1:]
    if 'M106' in line and senarelaggtyp != 0:
        senarelaggflakt = line
        utline = []
        print "tar bort: "+senarelaggflakt[:-1]

    # start
    # unload - precis innan utdrag
    # Tn
    # load - precis efter utdrag
    # wipe - rensning
    # end - ater till utskrift


# reduce temperature just before tool change (filament unload) and reset temperature directly after
# According to prusa MMU vs mk3 settings:
# PET 240 -> 230    = -10
# PLA 210 -> 205    = -5
# BVOH 210 -> 195   = -15


    if paustid > 0: # vi ska nu ska en langsam rorelse (forra raden var  CP TOOLCHANGE WIPE nu ar vi nasta varv i loopen)
        # Normalt = F1800 = 1800/60 = 30mm/s
        # F=mm/min = 1/60mm/s  30mm, 8s -> 30/8*60 
        flode = int(wipetowerbredd) / paustid * 60
#        utlines.append(ord[0]+" "+ord[1]+" "+ord[2]+" F"+ str(flode)+" ; FRIMMEL slow move as pause\n")
#        utlines.append(ord[0]+" "+ord[1]+" E0 F"+ str(flode)+" ; FRIMMEL slow move as pause\n")
        utlines.insert(len(utlines) - 2, ord[0]+" "+ord[1]+" E0 F"+ str(flode)+" ; FRIMMEL slow move as pause\n")
        print "paus "+str(paustid)+"s wipebredd="+str(wipetowerbredd)+"->"+ord[0]+" "+ord[1]+" E0 F"+ str(flode)+" ; FRIMMEL slow move as pause"
        utline = []
        paustid = 0

    if '; CP TOOLCHANGE START' in line:
        print "CP TOOLCHANGE START"

    if '; CP TOOLCHANGE LOAD' in line:
        print "CP TOOLCHANGE LOAD"
        if materialtyp != [] and "FLEX" in kommandematerialtyp: # Obs! KOMMANDE (inte nuvarande) materialtyp
            utlines.append("; FRIMMEL Load SLOW for FLEX (NOT reset by slic3r at Toolchange END)\n")
            utlines.append("M220 S30\n")
            print  "; FRIMMEL Unload SLOW for FLEX"



    if '; CP TOOLCHANGE UNLOAD' in line: # vi vill gora detta innan 'G1 E-15.0000 F6000'
         print "CP TOOLCHANGE UNLOAD"
         # Use temperatures (this will be overridden if detailed info is available later)
         if int(materialtemperaturer[int(extrudernummer)]) <= 999:
             sankttemperatur = 240
             materialtyp="???"
         if int(materialtemperaturer[int(extrudernummer)]) <= 260:
             sankttemperatur = 240
             materialtyp="3dkTOP ?"
         if int(materialtemperaturer[int(extrudernummer)]) <= 240:
             sankttemperatur = 195
             materialtyp="PETG ?"
         if int(materialtemperaturer[int(extrudernummer)]) <= 220:
             sankttemperatur = 195
             materialtyp="PLA ?"
         # PVA must (and can) be checked separately as temperatures overlap
         if ('PVA' in nyttmaterial):
             sankttemperatur = 200  # 195=for kallt int(temperatur) - 15
             materialtyp="BVOH"

         # Set detailed definition of filament if found in list
         filamentsort = filter(lambda element: materialtyper[int(extrudernummer)] in element[0], filamentsorter)
         if filamentsort != []:
             slicername=filamentsort[0][0][0]
             brandandtype=filamentsort[0][1][0]
             unloadtemp= filamentsort[0][2][0]
             maxwipetemp= filamentsort[0][3][0]
             materialtyp=materialtyper[int(extrudernummer)]
             sankttemperatur = unloadtemp;
             print brandandtype,"(filament unload temp=",unloadtemp,")"

         utlines.insert(len(utlines) - ANTALRADERINNANUNLOAD, "; FRIMMEL Temperatursankning innan filamenturdrag\n")
         utlines.insert(len(utlines) - ANTALRADERINNANUNLOAD,  "M104 S"+str(sankttemperatur)+" ; "+materialtyp+"\n")
         utlines.insert(len(utlines) - ANTALRADERINNANUNLOAD,  "M106 S255\n") ; 190802
         print "Temperatursankning innan filamenturdrag: "+materialtyp+": M104 S"+str(sankttemperatur)+" ( "+materialtyp+" )"
         aterstallningstid = 1.0*(int(temperatur)-sankttemperatur)/DELTATEMPFAKTOR - FILAMENTBYTESTID
         installningstid = 1.0*(int(temperatur)-sankttemperatur)/DELTATEMPNEDFAKTOR - FILAMENTURLADDTID # tiden att SANKA ar kortare an att hoja
# VANTA INTE HELA TIDEN vid denna sankning - det hinns med under processen!
         if installningstid > 0:
             utlines.append("G4 S"+str(installningstid)+" ; FRIMMEL - tillaggspaus for temperatursankning\n") # wait NN seconds (do NOT use M109 as time softens the filament

         aterstallningstemperatur = temperatur
         initialtemperatur = 0
         # from now on, only rely on newly harvested temperatures
         temperatur = []; # next temperature should be found after this point, or in emergency constructed at next Tn
         if materialtyp != [] and "FLEX" in materialtyp:
              utlines.append("; FRIMMEL Unload SLOW for FLEX (reset by slic3r at Tn)\n")
              utlines.append("M220 S30\n")
              print  "; FRIMMEL Unload SLOW for FLEX"


    if '; CP TOOLCHANGE WIPE' in line and aterstallningstemperatur != []: #          # and aterstallningstemperatur == temperatur: 
         print "CP TOOLCHANGE WIPE"
         if aterstallningstemperatur > temperatur: # only add extra boost if old filament has higher melting point than new filament
            wipetemperatur = int(aterstallningstemperatur) + WIPETEMPERATUROKNING
         else:
             wipetemperatur = int(aterstallningstemperatur)

#         if wipetemperatur > 250:    # MAXGRANS for extra temp.boost - INTE OK med tex 3dkTOP ??? 
#             wipetemperatur = 250;   # int(aterstallningstemperatur)
         # wipetemperatur setting if the NEXT temperature is as follows (IF MY DETAILED MATERIAL DEFINITIONS IN GCODE exists)

         # Set detailed definition of filament if found in list
         filamentsort = filter(lambda element: materialtyper[int(extrudernummer)] in element[0], filamentsorter)
         if filamentsort != []:
             slicername=filamentsort[0][0][0]
             brandandtype=filamentsort[0][1][0]
             unloadtemp= filamentsort[0][2][0]
             maxwipetemp= filamentsort[0][3][0]
             wipetemperatur = min (wipetemperatur, maxwipetemp) 
             print brandandtype,"(wipetemp=",wipetemperatur," maxwipetemp=",maxwipetemp,")"
         utlines.append("; FRIMMEL Temperaturaterstallning TILL LITE HOGRE efter filamenturdrag\n")
         utlines.append("M104 S"+str(wipetemperatur)+"\n")
#         utlines.append("M109 S"+str(aterstallningstemperatur)+"\n") # wait
         utlines.append("M106 S0\n") # no fan when increasing temperature
         paustid = aterstallningstid + (WIPETEMPERATUROKNING/DELTATEMPFAKTOR)
#         utlines.append("G4 S"+str(aterstallningstid + (WIPETEMPERATUROKNING/DELTATEMPFAKTOR))+"\n") # wait NN seconds (do NOT use M109 as time softens the filament

         print "Aterstaller temperatur TILL LITE HOGRE efter filamentutdrag: "+"M104 S"+str(wipetemperatur)+" (fan=off, wait for="+str(aterstallningstid + (WIPETEMPERATUROKNING/DELTATEMPFAKTOR))+"s )"
#         if temperatur != []:
         utlines.append("; FRIMMEL Now reduce/increase temperature gradually DURING wipe\n")
#         utlines.append("M104 S"+str(temperatur)+"\n") # NOW REDUCE temperature DURING the purging process
         print "Initierar temperaturgradient under wipe: M104 S"+str(temperatur)
         aterstallningstemperatur = [];
         aterstallningstid = [];
         wipestartlineindex = len(utlines) # starting point for temperature gradient


    if '; CP TOOLCHANGE END' in line:
        print "CP TOOLCHANGE END"
        # construct temperature gradient
        wipeendlineindex = len(utlines) # ending point for temperature gradient
        if temperatur != []:
            for i in range(wipestartlineindex, wipeendlineindex, (wipeendlineindex-wipestartlineindex)/10):
                print "M104 S"+ str(  int(wipetemperatur) - (wipetemperatur-int(temperatur))*(i-wipestartlineindex)/(wipeendlineindex-wipestartlineindex))
                utlines.insert(i,"M104 S"+ str(  int(wipetemperatur) - (wipetemperatur-int(temperatur))*(i-wipestartlineindex)/(wipeendlineindex-wipestartlineindex)  )+"; FRIMMEL temperature gradient at: "+str(i)+"\n")

        utlines.append("; FRIMMEL Senarelagd temperatur\n")
        if temperatur != []:
            utlines.append("M104 S"+temperatur+"\n")
            print "lagger in: M104 S"+temperatur+"\n"
        if flakt != []:
            utlines.append("M106 S"+flakt+"\n")
            print "lagger in: M106 S"+flakt+"\n"
        senarelaggtyp=0
        senarelagg=[]
        senarelaggflakt=[]
        kommandematerialtyp=[] # bara aktiv under materialbytet - FLEX ska vara langsamt BADEunder wipe och INNAN nasta materialbyte

#    if materialtyp != []  and "FLEX" in materialtyper[int(extrudernummer)]: # 
#    if materialtyp != []: # fusk - kommer ALLTID att bli langsamt
# aktivfas = [] # TOOLCHANGE START -> TOOLCHANGE UNLOAD -> (Tn) -> TOOLCHANGE LOAD  -> TOOLCHANGE WIPE ->  TOOLCHANGE END 
    if (materialtyp != []  and "FLEX" in materialtyp and aktivfas == "TOOLCHANGE UNLOAD") or (kommandematerialtyp != [] and "FLEX" in kommandematerialtyp and aktivfas == "TOOLCHANGE LOAD"):

        if "G1" in line and "X" in line and "E" in line and "F" in line and "E" in ord[2]:
            print "FRIMMEL: ", line
            pm = re.compile("E-\d\d")
            svar = pm.match(ord[2])
            if svar and "F" in ord[3]:
                print  "; FRIMMEL Filament transport SLOW for FLEX movement",line
                utline = ord[0]+" "+ord[1]+" "+ord[2]+" F300 ; FRIMMEL Filament transport SLOW for FLEX movement\n"
            pm = re.compile("E\d\d")
            svar = pm.match(ord[2])
            if svar and "F" in ord[3]:
                print  "; FRIMMEL Filament transport SLOW for FLEX movement",line
                utline = ord[0]+" "+ord[1]+" "+ord[2]+" F300 ; FRIMMEL Filament transport SLOW for FLEX movement\n"

# write current line
    if utline != []:
        utlines.append(utline)


# write resulting file
#utfilnamn = str(sys.argv[2])
utfilnamn="KORR_"+filnamn
utfil = open(utfilnamn, "w")
utfil.writelines(utlines)


# write final comment for slic3r

print(r"""
=================================================
================ please note ====================
=================================================
Filament types available: XT WoodFILL StoneFILL SteelFILL BrassFILL CPE-HG100 PET NinjaFLEX FilaFLEX SemiFLEX PLA PLA-PHA PP ELIXIR NYLON 3dkTOP BVOH PVA

For MMU2s to adapt to these types, please visit the file ~/.Slic3rPE/vendor/PrusaResearch.ini

*** WARNING! This is the original prusa settings file for slic3rPE. Do not edit it if you do not know what this is about. You might not be able to slice afterwards if you do something wrong ***

*** PLEASE NOTE: slic3r sets speed in gcode if EXACT keyword FLEX was found. Now you are in control! ***

In section "[printer:Original Prusa i3 MK3S MMU2S]", replace the M403-setup (there are five instances of M403) by the below gcode snippet.

In section "[printer:Original Prusa i3 MK3S MMU2S Single]", add the same snippet just after  "set units to millimeters\n\n"


\n; E stands for extruder number, F stands for filament type (0: default; 1:flex; 2: PVA)\nM403 E0 F{if filament_type[0]=~/.*FLEX.*/}1{else}{if filament_type[0]=~/.*BVOH.*/}2{else}{if filament_type[0]=~/.*PVA.*/}2{else}0{endif}{endif}{endif}\nM403 E1 F{if filament_type[1]=~/.*FLEX.*/}1{else}{if filament_type[1]=~/.*BVOH.*/}2{else}{if filament_type[1]=~/.*PVA.*/}2{else}0{endif}{endif}{endif}\nM403 E2 F{if filament_type[2]=~/.*FLEX.*/}1{else}{if filament_type[2]=~/.*BVOH.*/}2{else}{if filament_type[2]=~/.*PVA.*/}2{else}0{endif}{endif}{endif}\nM403 E3 F{if filament_type[3]=~/.*FLEX.*/}1{else}{if filament_type[3]=~/.*BVOH.*/}2{else}{if filament_type[3]=~/.*PVA.*/}2{else}0{endif}{endif}{endif}\nM403 E4 F{if filament_type[4]=~/.*FLEX.*/}1{else}{if filament_type[4]=~/.*BVOH.*/}2{else}{if filament_type[4]=~/.*PVA.*/}2{else}0{endif}{endif}{endif}
""")

#  utlines.insert(len(utlines) - ANTALRADERINNANUNLOAD, "; FRIMMEL Temperatursankning innan filamenturdrag\n")


print "Skapat utfil: "+utfilnamn
